﻿unit Data;

uses GData,System.Drawing;

const
  RW = 2500;
  MazeRad = 20;
  MazeMaxRad = 100;
  RoomDrawLimit = 1;
  RoomGetAttempts = 100;
  MapW = 100;
  MapH = 100;

var
  aPF0 := new PointF[0];
  
  LH := -1;

function ArcTg(dx, dy: real): real:= (dx = 0 ? dy > 0 ? Pi / 2 : -Pi / 2 : ArcTan(dy / dx)) + (dx < 0 ? Pi : 0);

function Rotate(a, b, rot: real): PointF;
begin
  with Result do
  begin
    var r := sqrt(sqr(a) + sqr(b));
    var ang := ArcTg(a, b) + rot;
    X := Cos(ang) * r;
    Y := Sin(ang) * r;
  end;
end;

function Rotate(a: array of PointF; rot: real): array of PointF;
begin
  Result := new PointF[a.Length];
  for i: integer := 0 to a.Length - 1 do
    a[i] := Rotate(a[i].X, a[i].Y, rot);
  Result := a;
end;

function Rotate(p: PointF; rot: real):= Rotate(p.X, p.Y, rot);

function Isept(dr: real; p11, p12, p21: PointF; var d22: PointF): boolean;
begin
  var p22 := new PointF(p21.X + d22.X, p21.Y + d22.Y);
  
  var a1 := (p11.Y - p12.Y) / (p11.X - p12.X);if a1.Equals(real.NegativeInfinity) then a1 := real.PositiveInfinity;
  var b1 := a1.Equals(real.PositiveInfinity) ? p11.X : p11.Y - a1 * p11.X;
  var a2 := (p21.Y - p22.Y) / (p21.X - p22.X);if a2.Equals(real.NegativeInfinity) then a2 := real.PositiveInfinity;
  var b2 := a2.Equals(real.PositiveInfinity) ? p21.X : p21.Y - a2 * p21.X;
  
  var Res: PointF;
  
  if a1 = a2 then exit;
  
  if a1.Equals(real.PositiveInfinity) then
    Res := new PointF(b1, a2 * b1 + b2) else
  if a2.Equals(real.PositiveInfinity) then
    Res := new PointF(b2, a1 * b2 + b1) else
  begin
    Res.X := -(b1 - b2) / (a1 - a2);
    Res.Y := a1 * Res.X + b1;
  end;
  
  var H1 := a1.Equals(real.PositiveInfinity);
  var H2 := a2.Equals(real.PositiveInfinity);
  var V1 := a1 = 0;
  var V2 := a2 = 0;
  
  if
  (H1 or ((p11.X < p12.X) ? (p11.X - dr < Res.X) and (Res.X - dr < p12.X) : (p11.X + dr > Res.X) and (Res.X + dr > p12.X))) and
  (V1 or ((p11.Y < p12.Y) ? (p11.Y - dr < Res.Y) and (Res.Y - dr < p12.Y) : (p11.Y + dr > Res.Y) and (Res.Y + dr > p12.Y))) and
  (H2 or ((p21.X < p22.X) ? (p21.X - dr < Res.X) and (Res.X - dr < p22.X) : (p21.X + dr > Res.X) and (Res.X + dr > p22.X))) and
  (V2 or ((p21.Y < p22.Y) ? (p21.Y - dr < Res.Y) and (Res.Y - dr < p22.Y) : (p21.Y + dr > Res.Y) and (Res.Y + dr > p22.Y))) then
  begin
    Result := true;
    
    a2 := -1 / a1;if a2.Equals(real.NegativeInfinity) then a2 := real.PositiveInfinity;
    b2 := a2.Equals(real.PositiveInfinity) ? p22.X : p22.Y - a2 * p22.X;
    
    if a1.Equals(real.PositiveInfinity) then
      Res := new PointF(b1, a2 * b1 + b2) else
    if a2.Equals(real.PositiveInfinity) then
      Res := new PointF(b2, a1 * b2 + b1) else
    begin
      Res.X := -(b1 - b2) / (a1 - a2);
      Res.Y := a1 * Res.X + b1;
    end;
    
    if a2.Equals(real.PositiveInfinity) then
    begin
      if p11.X < p12.X then
        Res.Y += dr else
        Res.Y -= dr;
    end else
    begin
      var dx := sqrt(sqr(dr) / (sqr(a2) + 1));
      if p11.Y < p12.Y then
        Res.X -= dx else
        Res.X += dx;
      Res.Y := a2 * Res.X + b2;
    end;
    
    {
    var r := sqrt(sqr(Res.X-p22.X)+sqr(Res.Y-p22.Y));
    Res.X := (Res.X-p22.X)/r*(r+dr)+p22.X;
    Res.Y := (Res.Y-p22.Y)/r*(r+dr)+p22.Y;
    {}
    
    d22.X := Res.X - p21.X;
    d22.Y := Res.Y - p21.Y;
    
    if sqrt(sqr(d22.X) + sqr(d22.Y)) < 0.1 then
    begin
      d22.X := 0;
      d22.Y := 0;
    end;
  end;
end;

procedure TestHit(dr: real; l: array of PointF; from: PointF; var Sp: PointF);
begin
  var Hit := true;
  var Hn := 0;
  var Hited := new boolean[l.Length];
  
  while Hit and (Hn <= 3) do
  begin
    Hit := false;
    for i: integer := 0 to l.Length - 1 do
      if not Hited[i] then
        if Isept(dr, l[i], l[(i = l.Length - 1) ? 0 : i + 1], from, Sp) then
        begin
          Hit := true;
          Hited[i] := true;
          
          LH := i;
          
          break;
        end;
    Hn += 1;
  end;
end;

function Add(p: array of PointF; dX, dY: real): array of PointF;
begin
  for i: integer := 0 to p.Length - 1 do
  begin
    p[i].X += dX;
    p[i].Y += dY;
  end;
  Result := p;
end;

function Mlt(p: array of PointF; r: real): array of PointF;
begin
  for i: integer := 0 to p.Length - 1 do
  begin
    p[i].X *= r;
    p[i].Y *= r;
  end;
  Result := p;
end;

type
  PlTexture = record
  
  end;
  Player = record
    class X, Y, dX, dY: real;
    class Hp := 200.0;
    class Rot: real;
    
    class Draw: PlTexture;
  end;
  
  
  Textures = record
    class HpIcon := new Bitmap('Textures\Health Icon.bmp');
  end;
  
  
  CreateRoomParameter = record
    X, Y: integer;
    
    constructor create(X, Y: integer);
    begin
      self.X := X;
      self.Y := Y;
    end;
  end;
  
  ///Direction:
  ///Norm={R,D,L,U}
  ///State={L,R,U,D}
  StateT = record
    data: byte;
    
    function L := byte(data shr 6);
    function R := byte(byte(data shl 2) shr 6);
    function U := byte(byte(data shl 4) shr 6);
    function D := byte(byte(data shl 6) shr 6);
    
    constructor create(L, R, U, D: boolean);
    begin
      data := (L ? 128 : 0) + (R ? 32 : 0) + (U ? 8 : 0) + (D ? 2 : 0);
    end;
    
    constructor create(L, R, U, D: byte);
    begin
      L := L mod 4;R := R mod 4;U := U mod 4;D := D mod 4;
      data := L * 64 + R * 16 + U * 4 + D;
    end;
    
    constructor create(data: byte);
    begin
      self.data := data;
    end;
  end;
  
  pSegDataPack = ^SegDataPack;
  Segment = interface
    function Draw(Way: byte; steps: integer): array of PointF;
    
    procedure SetCon(SL, SR, SU, SD: Segment);
    
    procedure AddSL(o: Segment);
    
    procedure AddSR(o: Segment);
    
    procedure AddSU(o: Segment);
    
    procedure AddSD(o: Segment);
    
    function GetData: pSegDataPack;
    
    function GetEmpty: array of CreateRoomParameter;
    
    procedure SetPos(X, Y: integer);
    
    function X: integer;
    function Y: integer;
  end;
  
  pEGiD = ^EGiD;
  pEGeD = ^EGeD;
  Entity = interface
    
    procedure GiveData(o: pEGiD);
    
    function GetData: pEGeD;
  
  end;
  
  SegDataPack = record
    S: array of Segment;
    State: StateT;
  end;
  
  EGiD = record
  
  end;
  EGeD = record
  
  end;
  
  Mob = class(Entity)
  public 
    
    procedure GiveData(o: pEGiD);
    begin
      
    end;
    
    function GetData: pEGeD;
    begin
      
    end;
  
  end;
  
  Rarity = record
  public 
    const Hall = 4;
    const Canal = 2;
    const Corner = 10;
    const TSeg = 2;
    const Treasury = 1000;
  end;
  Hall = class(Segment)
    SL, SR, SU, SD: Segment;
    nX, nY: integer;
    
    class RU := Mlt(new PointF[5](new PointF(0.550, 0.000), new PointF(0.600, 0.200), new PointF(0.800, 0.200), new PointF(0.800, 0.400), new PointF(1.000, 0.450)), RW);
    class RD := Mlt(new PointF[5](new PointF(1.000, 0.550), new PointF(0.800, 0.600), new PointF(0.800, 0.800), new PointF(0.600, 0.800), new PointF(0.550, 1.000)), RW);
    class LU := Mlt(new PointF[5](new PointF(0.000, 0.450), new PointF(0.200, 0.400), new PointF(0.200, 0.200), new PointF(0.400, 0.200), new PointF(0.450, 0.000)), RW);
    class LD := Mlt(new PointF[5](new PointF(0.450, 1.000), new PointF(0.400, 0.800), new PointF(0.200, 0.800), new PointF(0.200, 0.600), new PointF(0.000, 0.550)), RW);
    
    class function Fit(State: StateT): boolean;
    begin
      var L := State.L;
      var R := State.R;
      var U := State.U;
      var D := State.D;
      Result := (L > 0) and (R > 0) and (U > 0) and (D > 0) and (L + R + U + D - 4 > Random * Rarity.Hall);
    end;
    
    constructor create(X, Y: integer);
    begin
      self.nX := X;
      self.nY := Y;
    end;
    
    public function Draw(Way: byte; steps: integer): array of PointF;
    var
      R, D, L, U: array of PointF;
    begin
      if Way <> 1 then R := (SR <> nil) and (steps > 0) ? Add(SR.Draw(3, steps - 1), RW, 0) : aPF0;
      if Way <> 2 then D := (SD <> nil) and (steps > 0) ? Add(SD.Draw(4, steps - 1), 0, RW) : aPF0;
      if Way <> 3 then L := (SL <> nil) and (steps > 0) ? Add(SL.Draw(1, steps - 1), -RW, 0) : aPF0;
      if Way <> 4 then U := (SU <> nil) and (steps > 0) ? Add(SU.Draw(2, steps - 1), 0, -RW) : aPF0;
      case Way of
        0: Result := RU + R + RD + D + LD + L + LU + U;
        1: Result := RD + D + LD + L + LU + U + RU;
        2: Result := LD + L + LU + U + RU + R + RD;
        3: Result := LU + U + RU + R + RD + D + LD;
        4: Result := RU + R + RD + D + LD + L + LU;
      end;
    end;
    
    procedure SetCon(SL, SR, SU, SD: Segment);
    begin
      self.SL := SL;
      self.SR := SR;
      self.SU := SU;
      self.SD := SD;
    end;
    
    procedure AddSL(o: Segment);
    begin
      SL := o;
    end;
    
    procedure AddSR(o: Segment);
    begin
      SR := o;
    end;
    
    procedure AddSU(o: Segment);
    begin
      SU := o;
    end;
    
    procedure AddSD(o: Segment);
    begin
      SD := o;
    end;
    
    function GetData: pSegDataPack;
    begin
      var a: SegDataPack;
      a.S := new Segment[4](SR, SD, SL, SU);
      a.State.data := 170;//10 10 10 10
      Result := @a;
    end;
    
    function GetEmpty: array of CreateRoomParameter;
    begin
      Result := new CreateRoomParameter[0];
      if SL = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX - 1, nY));
      if SR = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX + 1, nY));
      if SU = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX, nY - 1));
      if SD = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX, nY + 1));
    end;
    
    procedure SetPos(X, Y: integer);
    begin
      nX := X;
      nY := Y;
    end;
    
    function X := self.nX;
    function Y := self.nY;
  end;
  Canal = class(Segment)
    State: StateT;
    SL, SR, SU, SD: Segment;
    nX, nY: integer;
    
    class WL := Mlt(new PointF[4](new PointF(0.450, 1.000), new PointF(0.400, 0.800), new PointF(0.400, 0.200), new PointF(0.450, 0.000)), RW);
    class WR := Mlt(new PointF[4](new PointF(0.550, 0.000), new PointF(0.600, 0.200), new PointF(0.600, 0.800), new PointF(0.550, 1.000)), RW);
    
    class WU := Mlt(new PointF[4](new PointF(0.000, 0.450), new PointF(0.200, 0.400), new PointF(0.800, 0.400), new PointF(1.000, 0.450)), RW);
    class WD := Mlt(new PointF[4](new PointF(1.000, 0.550), new PointF(0.800, 0.600), new PointF(0.200, 0.600), new PointF(0.000, 0.550)), RW);
    
    class function Fit(State: StateT): boolean;
    begin
      var L := State.L > 0;var R := State.R > 0;var U := State.U > 0;var D := State.D > 0;
      var nL := State.L < 2;var nR := State.R < 2;var nU := State.U < 2;var nD := State.D < 2;
      Result := ((L and R and nU and nD) or (nL and nR and U and D)) and (State.R + State.D + State.L + State.U > Random * Rarity.Canal);
    end;
    
    constructor create(State: StateT; X, Y: integer);
    begin
      var Hor: boolean;
      if (State.L = 2) or (State.R = 2) or (State.U = 0) or (State.D = 0) then
        Hor := true else
      if (State.U = 2) or (State.D = 2) or (State.L = 0) or (State.R = 0) then
        Hor := false else
        Hor := Random(2) = 0;
      if Hor then
        self.State := new StateT(true, true, false, false) else
        self.State := new StateT(false, false, true, true);
      
      self.nX := X;
      self.nY := Y;
    end;
    
    public function Draw(Way: byte; steps: integer): array of PointF;
    begin
      case Way of
        0:
          Result := 
                          State.L = 2 ?
                          WU + ((SR <> nil) and (steps > 0) ? Add(SR.Draw(3, steps - 1), RW, 0) : aPF0) + WD + ((SL <> nil) and (steps > 0) ? Add(SL.Draw(1, steps - 1), -RW, 0) : aPF0) :
                          WR + ((SD <> nil) and (steps > 0) ? Add(SD.Draw(4, steps - 1), 0, RW) : aPF0) + WL + ((SU <> nil) and (steps > 0) ? Add(SU.Draw(2, steps - 1), 0, -RW) : aPF0);
        1: Result := WD + ((SL <> nil) and (steps > 0) ? Add(SL.Draw(1, steps - 1), -RW, 0) : aPF0) + WU;
        2: Result := WL + ((SU <> nil) and (steps > 0) ? Add(SU.Draw(2, steps - 1), 0, -RW) : aPF0) + WR;
        3: Result := WU + ((SR <> nil) and (steps > 0) ? Add(SR.Draw(3, steps - 1), RW, 0) : aPF0) + WD;
        4: Result := WR + ((SD <> nil) and (steps > 0) ? Add(SD.Draw(4, steps - 1), 0, RW) : aPF0) + WL;
      end;
    end;
    
    procedure SetCon(SL, SR, SU, SD: Segment);
    begin
      self.SL := SL;
      self.SR := SR;
      self.SU := SU;
      self.SD := SD;
    end;
    
    procedure AddSL(o: Segment);
    begin
      SL := o;
    end;
    
    procedure AddSR(o: Segment);
    begin
      SR := o;
    end;
    
    procedure AddSU(o: Segment);
    begin
      SU := o;
    end;
    
    procedure AddSD(o: Segment);
    begin
      SD := o;
    end;
    
    function GetData: pSegDataPack;
    begin
      var a: SegDataPack;
      a.S := new Segment[4](SR, SD, SL, SU);
      a.State := State;
      Result := @a;
    end;
    
    function GetEmpty: array of CreateRoomParameter;
    begin
      Result := new CreateRoomParameter[0];
      if State.L = 2 then if SL = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX - 1, nY));
      if State.R = 2 then if SR = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX + 1, nY));
      if State.U = 2 then if SU = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX, nY - 1));
      if State.D = 2 then if SD = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX, nY + 1));
    end;
    
    procedure SetPos(X, Y: integer);
    begin
      nX := X;
      nY := Y;
    end;
    
    function X := self.nX;
    function Y := self.nY;
  end;
  Corner = class(Segment)
    State: StateT;
    SL, SR, SU, SD: Segment;
    nX, nY: integer;
    Rot: byte;
    
    class ConS := Mlt(new PointF[5](new PointF(1.000, 0.550), new PointF(0.990, 0.550), new PointF(0.990, 0.990), new PointF(0.550, 0.990), new PointF(0.550, 1.000)), RW);
    class ConB := Mlt(new PointF[7](new PointF(0.450, 1.000), new PointF(0.450, 0.990), new PointF(0.010, 0.990), new PointF(0.010, 0.010), new PointF(0.990, 0.010), new PointF(0.990, 0.450), new PointF(1.000, 0.450)), RW);
    
    class function Fit(State: StateT): boolean;
    begin
      var L := State.L;var R := State.R;var U := State.U;var D := State.D;
      
      Result := (
      ((R > 0) and (D > 0) and (L < 2) and (U < 2)) or
      ((D > 0) and (L > 0) and (U < 2) and (R < 2)) or
      ((L > 0) and (U > 0) and (R < 2) and (D < 2)) or
      ((U > 0) and (R > 0) and (D < 2) and (L < 2))
      ) and (L + R + U + D - 2 > Random * Rarity.Corner);
    end;
    
    constructor create(State: StateT; X, Y: integer);
    var
      RD, DL, LU, UR: boolean;
    begin
      begin
        var L := State.L;var R := State.R;var U := State.U;var D := State.D;
        RD := (R > 0) and (D > 0) and (L < 2) and (U < 2);
        DL := (D > 0) and (L > 0) and (U < 2) and (R < 2);
        LU := (L > 0) and (U > 0) and (R < 2) and (D < 2);
        UR := (U > 0) and (R > 0) and (D < 2) and (L < 2);
      end;
      
      while true do
      begin
        Rot := Random(4);
        var Fit := false;
        case Rot of
          0: Fit := RD;
          1: Fit := DL;
          2: Fit := LU;
          3: Fit := UR;
        end;
        if Fit then break;
      end;
      
      case Rot of
        0: self.State := new StateT(false, true, false, true);
        1: self.State := new StateT(true, false, false, true);
        2: self.State := new StateT(true, false, true, false);
        3: self.State := new StateT(false, true, true, false);
      end;
      
      self.nX := X;
      self.nY := Y;
    end;
    
    public function Draw(Way: byte; steps: integer): array of PointF;
    begin
      var B := Copy(ConB);
      var S := Copy(ConS);
      if Rot > 0 then
      begin
        B := Add(Rotate(Add(B, -0.5 * RW, -0.5 * RW), Pi / 2 * Rot), 0.5 * RW, 0.5 * RW);
        S := Add(Rotate(Add(S, -0.5 * RW, -0.5 * RW), Pi / 2 * Rot), 0.5 * RW, 0.5 * RW);
      end;
      if Way = 0 then
        case Rot of
          0: Result := S + ((SD <> nil) and (steps > 0) ? Add(SD.Draw(4, steps - 1), 0, RW) : aPF0) + B + ((SR <> nil) and (steps > 0) ? Add(SR.Draw(3, steps - 1), RW, 0) : aPF0);
          1: Result := S + ((SL <> nil) and (steps > 0) ? Add(SL.Draw(1, steps - 1), -RW, 0) : aPF0) + B + ((SD <> nil) and (steps > 0) ? Add(SD.Draw(4, steps - 1), 0, RW) : aPF0);
          2: Result := S + ((SU <> nil) and (steps > 0) ? Add(SU.Draw(2, steps - 1), 0, -RW) : aPF0) + B + ((SL <> nil) and (steps > 0) ? Add(SL.Draw(1, steps - 1), -RW, 0) : aPF0);
          3: Result := S + ((SR <> nil) and (steps > 0) ? Add(SR.Draw(3, steps - 1), RW, 0) : aPF0) + B + ((SU <> nil) and (steps > 0) ? Add(SU.Draw(2, steps - 1), 0, -RW) : aPF0);
        end else
      if Way = Rot + 1 then
        case Rot of
          0: Result := S + ((SD <> nil) and (steps > 0) ? Add(SD.Draw(4, steps - 1), 0, RW) : aPF0) + B;
          1: Result := S + ((SL <> nil) and (steps > 0) ? Add(SL.Draw(1, steps - 1), -RW, 0) : aPF0) + B;
          2: Result := S + ((SU <> nil) and (steps > 0) ? Add(SU.Draw(2, steps - 1), 0, -RW) : aPF0) + B;
          3: Result := S + ((SR <> nil) and (steps > 0) ? Add(SR.Draw(3, steps - 1), RW, 0) : aPF0) + B;
        end else
        case Rot of
          0: Result := B + ((SR <> nil) and (steps > 0) ? Add(SR.Draw(3, steps - 1), RW, 0) : aPF0) + S;
          1: Result := B + ((SD <> nil) and (steps > 0) ? Add(SD.Draw(4, steps - 1), 0, RW) : aPF0) + S;
          2: Result := B + ((SL <> nil) and (steps > 0) ? Add(SL.Draw(1, steps - 1), -RW, 0) : aPF0) + S;
          3: Result := B + ((SU <> nil) and (steps > 0) ? Add(SU.Draw(2, steps - 1), 0, -RW) : aPF0) + S;
        end;
    end;
    
    procedure SetCon(SL, SR, SU, SD: Segment);
    begin
      self.SL := SL;
      self.SR := SR;
      self.SU := SU;
      self.SD := SD;
    end;
    
    procedure AddSL(o: Segment);
    begin
      SL := o;
    end;
    
    procedure AddSR(o: Segment);
    begin
      SR := o;
    end;
    
    procedure AddSU(o: Segment);
    begin
      SU := o;
    end;
    
    procedure AddSD(o: Segment);
    begin
      SD := o;
    end;
    
    function GetData: pSegDataPack;
    begin
      var a: SegDataPack;
      a.S := new Segment[4](SR, SD, SL, SU);
      a.State := State;
      Result := @a;
    end;
    
    function GetEmpty: array of CreateRoomParameter;
    begin
      Result := new CreateRoomParameter[0];
      if State.L = 2 then if SL = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX - 1, nY));
      if State.R = 2 then if SR = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX + 1, nY));
      if State.U = 2 then if SU = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX, nY - 1));
      if State.D = 2 then if SD = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX, nY + 1));
    end;
    
    procedure SetPos(X, Y: integer);
    begin
      nX := X;
      nY := Y;
    end;
    
    function X := self.nX;
    function Y := self.nY;
  end;
  TSeg = class(Segment)
    State: StateT;
    SL, SR, SU, SD: Segment;
    nX, nY: integer;
    Rot: byte;
    
    class ConU := Mlt(new PointF[3](new PointF(0.000, 0.450), new PointF(0.250, 0.450), new PointF(0.450, 0.000)), RW);
    class ConD := Mlt(new PointF[3](new PointF(0.450, 1.000), new PointF(0.250, 0.550), new PointF(0.000, 0.550)), RW);
    
    class Mid := Mlt(new PointF[21](
    new PointF(0.550, 0.000), new PointF(0.450, 0.450),
    new PointF(0.505, 0.450),
    new PointF(0.519, 0.404), new PointF(0.573, 0.323), new PointF(0.654, 0.269),
    new PointF(0.750, 0.250),
    new PointF(0.846, 0.269), new PointF(0.927, 0.323), new PointF(0.981, 0.404),
    new PointF(1.000, 0.500),
    new PointF(0.981, 0.596), new PointF(0.927, 0.677), new PointF(0.846, 0.731),
    new PointF(0.750, 0.750),
    new PointF(0.654, 0.731), new PointF(0.573, 0.677), new PointF(0.519, 0.596),
    new PointF(0.505, 0.550),
    new PointF(0.450, 0.550), new PointF(0.550, 1.000)), RW);
    
    class function Fit(State: StateT): boolean;
    begin
      var L := State.L;var R := State.R;var U := State.U;var D := State.D;
      
      Result :=
      ((R < 2) and (D > 0) and (L > 0) and (U > 0)) or
      ((D < 2) and (L > 0) and (U > 0) and (R > 0)) or
      ((L < 2) and (U > 0) and (R > 0) and (D > 0)) or
      ((U < 2) and (R > 0) and (D > 0) and (L > 0));
      Result := Result and (L + R + U + D - 4 > Random * Rarity.TSeg);
    end;
    
    constructor create(State: StateT; X, Y: integer);
    var
      nR, nD, nL, nU: boolean;
    begin
      begin
        var L := State.L;var R := State.R;var U := State.U;var D := State.D;
        nR := ((R < 2) and (D > 0) and (L > 0) and (U > 0));
        nD := ((D < 2) and (L > 0) and (U > 0) and (R > 0));
        nL := ((L < 2) and (U > 0) and (R > 0) and (D > 0));
        nU := ((U < 2) and (R > 0) and (D > 0) and (L > 0));
      end;
      
      while true do
      begin
        Rot := Random(4);
        var Fit := false;
        case Rot of
          0: Fit := nR;
          1: Fit := nD;
          2: Fit := nL;
          3: Fit := nU;
        end;
        if Fit then break;
      end;
      
      case Rot of
        0: self.State := new StateT(true, false, true, true);
        1: self.State := new StateT(true, true, true, false);
        2: self.State := new StateT(false, true, true, true);
        3: self.State := new StateT(true, true, false, true);
      end;
      
      self.nX := X;
      self.nY := Y;
    end;
    
    public function Draw(Way: byte; steps: integer): array of PointF;
    begin
      var U := Copy(ConU);
      var D := Copy(ConD);
      var M := Copy(Mid);
      if Rot > 0 then
      begin
        U := Add(Rotate(Add(U, -0.5 * RW, -0.5 * RW), Pi / 2 * Rot), 0.5 * RW, 0.5 * RW);
        D := Add(Rotate(Add(D, -0.5 * RW, -0.5 * RW), Pi / 2 * Rot), 0.5 * RW, 0.5 * RW);
        M := Add(Rotate(Add(M, -0.5 * RW, -0.5 * RW), Pi / 2 * Rot), 0.5 * RW, 0.5 * RW);
      end;
      
      var PR := (Rot <> 0) and (SR <> nil) and (steps > 0) ? Add(SR.Draw(3, steps - 1), RW, 0) : aPF0;
      var PD := (Rot <> 1) and (SD <> nil) and (steps > 0) ? Add(SD.Draw(4, steps - 1), 0, RW) : aPF0;
      var PL := (Rot <> 2) and (SL <> nil) and (steps > 0) ? Add(SL.Draw(1, steps - 1), -RW, 0) : aPF0;
      var PU := (Rot <> 3) and (SU <> nil) and (steps > 0) ? Add(SU.Draw(2, steps - 1), 0, -RW) : aPF0;
      
      if Way = 0 then
        case Rot of
          0: Result := M + PD + D + PL + U + PU;
          1: Result := M + PL + D + PU + U + PR;
          2: Result := M + PU + D + PR + U + PD;
          3: Result := M + PR + D + PD + U + PL;
        end else
      if Way mod 4 = ((Rot + 2) mod 4) then
        case Rot of
          0: Result := D + PL + U + PU + M;
          1: Result := D + PU + U + PR + M;
          2: Result := D + PR + U + PD + M;
          3: Result := D + PD + U + PL + M;
        end else
      if Way mod 4 = ((Rot + 3) mod 4) then
        case Rot of
          0: Result := U + PU + M + PD + D;
          1: Result := U + PR + M + PL + D;
          2: Result := U + PD + M + PU + D;
          3: Result := U + PL + M + PR + D;
        end else
        case Rot of
          0: Result := M + PD + D + PL + U;
          1: Result := M + PL + D + PU + U;
          2: Result := M + PU + D + PR + U;
          3: Result := M + PR + D + PD + U;
        end;
    end;
    
    procedure SetCon(SL, SR, SU, SD: Segment);
    begin
      self.SL := SL;
      self.SR := SR;
      self.SU := SU;
      self.SD := SD;
    end;
    
    procedure AddSL(o: Segment);
    begin
      SL := o;
    end;
    
    procedure AddSR(o: Segment);
    begin
      SR := o;
    end;
    
    procedure AddSU(o: Segment);
    begin
      SU := o;
    end;
    
    procedure AddSD(o: Segment);
    begin
      SD := o;
    end;
    
    function GetData: pSegDataPack;
    begin
      var a: SegDataPack;
      a.S := new Segment[4](SR, SD, SL, SU);
      a.State := State;
      Result := @a;
    end;
    
    function GetEmpty: array of CreateRoomParameter;
    begin
      Result := new CreateRoomParameter[0];
      if State.L = 2 then if SL = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX - 1, nY));
      if State.R = 2 then if SR = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX + 1, nY));
      if State.U = 2 then if SU = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX, nY - 1));
      if State.D = 2 then if SD = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX, nY + 1));
    end;
    
    procedure SetPos(X, Y: integer);
    begin
      nX := X;
      nY := Y;
    end;
    
    function X := self.nX;
    function Y := self.nY;
  end;
  Treasury = class(Segment)
    State: StateT;
    SL, SR, SU, SD: Segment;
    nX, nY: integer;
    Rot: byte;
    
    class Room := new PointF[4](new PointF(RW, RW), new PointF(0, RW), new PointF(0, 0), new PointF(RW, 0));
    
    class function Fit(State: StateT): boolean;
    begin
      var L := State.L;var R := State.R;var U := State.U;var D := State.D;
      
      Result := (L + R + U + D = 2) and (1 > Random * Rarity.Treasury);
    end;
    
    constructor create(State: StateT; X, Y: integer);
    begin
      var L := State.L > 0;var R := State.R > 0;var U := State.U > 0;var D := State.D > 0;
      
      while true do
      begin
        var Fit := false;
        Rot := Random(4);
        case Rot of
          0: Fit := R;
          1: Fit := D;
          2: Fit := L;
          3: Fit := U;
        end;
        if Fit then break;
      end;
      
      self.State := new StateT(Rot = 2, Rot = 0, Rot = 3, Rot = 1);
      self.nX := X;
      self.nY := Y;
    end;
    
    public function Draw(Way: byte; steps: integer): array of PointF;
    begin
      if Way > 0 then
        Result := Add(Rotate(Add(Copy(Room), -0.5 * RW, -0.5 * RW), Pi / 2 * Rot), 0.5 * RW, 0.5 * RW) else
        case Rot of
          0: Result := Room + ((SR <> nil) and (steps > 0) ? Add(SR.Draw(3, steps - 1), RW, 0) : aPF0);
          1: Result := (Add(Rotate(Add(Copy(Room), -0.5 * RW, -0.5 * RW), Pi * 0.5), 0.5 * RW, 0.5 * RW)) + ((SD <> nil) and (steps > 0) ? Add(SD.Draw(4, steps - 1), 0, RW) : aPF0);
          2: Result := (Add(Rotate(Add(Copy(Room), -0.5 * RW, -0.5 * RW), Pi * 1.0), 0.5 * RW, 0.5 * RW)) + ((SL <> nil) and (steps > 0) ? Add(SL.Draw(1, steps - 1), -RW, 0) : aPF0);
          3: Result := (Add(Rotate(Add(Copy(Room), -0.5 * RW, -0.5 * RW), Pi * 1.5), 0.5 * RW, 0.5 * RW)) + ((SU <> nil) and (steps > 0) ? Add(SU.Draw(2, steps - 1), 0, -RW) : aPF0);
        end;
    end;
    
    procedure SetCon(SL, SR, SU, SD: Segment);
    begin
      self.SL := SL;
      self.SR := SR;
      self.SU := SU;
      self.SD := SD;
    end;
    
    procedure AddSL(o: Segment);
    begin
      SL := o;
    end;
    
    procedure AddSR(o: Segment);
    begin
      SR := o;
    end;
    
    procedure AddSU(o: Segment);
    begin
      SU := o;
    end;
    
    procedure AddSD(o: Segment);
    begin
      SD := o;
    end;
    
    function GetData: pSegDataPack;
    begin
      var a: SegDataPack;
      a.S := new Segment[4](SR, SD, SL, SU);
      a.State := State;
      Result := @a;
    end;
    
    function GetEmpty: array of CreateRoomParameter;
    begin
      Result := new CreateRoomParameter[0];
      if State.L = 2 then if SL = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX - 1, nY));
      if State.R = 2 then if SR = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX + 1, nY));
      if State.U = 2 then if SU = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX, nY - 1));
      if State.D = 2 then if SD = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX, nY + 1));
    end;
    
    procedure SetPos(X, Y: integer);
    begin
      nX := X;
      nY := Y;
    end;
    
    function X := self.nX;
    function Y := self.nY;
  end;
  
  SegVoid = class(Segment)
    State: StateT;
    SL, SR, SU, SD: Segment;
    nX, nY: integer;
    
    class function Fit(State: StateT): boolean;
    begin
      //var L := State.L;var R := State.R;var U := State.U;var D := State.D;
      
      Result := true;
    end;
    
    constructor create(State: StateT; X, Y: integer);
    begin
      
      
      self.nX := X;
      self.nY := Y;
    end;
    
    public function Draw(Way: byte; steps: integer): array of PointF;
    begin
      Result := aPF0;
    end;
    
    procedure SetCon(SL, SR, SU, SD: Segment);
    begin
      self.SL := SL;
      self.SR := SR;
      self.SU := SU;
      self.SD := SD;
    end;
    
    procedure AddSL(o: Segment);
    begin
      SL := o;
    end;
    
    procedure AddSR(o: Segment);
    begin
      SR := o;
    end;
    
    procedure AddSU(o: Segment);
    begin
      SU := o;
    end;
    
    procedure AddSD(o: Segment);
    begin
      SD := o;
    end;
    
    function GetData: pSegDataPack;
    begin
      var a: SegDataPack;
      a.S := new Segment[4](SR, SD, SL, SU);
      a.State := State;
      Result := @a;
    end;
    
    function GetEmpty: array of CreateRoomParameter;
    begin
      Result := new CreateRoomParameter[0];
      if State.L = 2 then if SL = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX - 1, nY));
      if State.R = 2 then if SR = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX + 1, nY));
      if State.U = 2 then if SU = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX, nY - 1));
      if State.D = 2 then if SD = nil then Result := Result + new CreateRoomParameter[1](new CreateRoomParameter(nX, nY + 1));
    end;
    
    procedure SetPos(X, Y: integer);
    begin
      nX := X;
      nY := Y;
    end;
    
    function X := self.nX;
    function Y := self.nY;
  end;
  
  
  Dangeon = record
    class RoomArray: array of Segment;
    
    class RoomWait := new CreateRoomParameter[0];
    
    class function GetSegment(X, Y: integer): Segment;
    begin
      for i: integer := 0 to RoomArray.Length - 1 do
        if (RoomArray[i].X = X) and (RoomArray[i].Y = Y) then
        begin
          Result := RoomArray[i];
          exit;
        end;
    end;
    
    {$region New}
    
    class function RandSegment(State: StateT; X, Y: integer): Segment;
    begin
      var Attempts := RoomGetAttempts;
      if sqrt(sqr(X) + sqr(Y)) <= RoomDrawLimit then Attempts := 10000;
      var n: integer;
      for nn: integer := 1 to Attempts do
      begin
        n := Random(5);
        var Fit: boolean;
        case n of
          0: Fit := Hall.Fit(State);
          1: Fit := Canal.Fit(State);
          2: Fit := Corner.Fit(State);
          3: Fit := TSeg.Fit(State);
          4: Fit := Treasury.Fit(State);
        end;
        if Fit then break;
        
        if nn = Attempts then
          exit;
      end;
      
      case n of
        0: Result := new Hall(X, Y);
        1: Result := new Canal(State, X, Y);
        2: Result := new Corner(State, X, Y);
        3: Result := new TSeg(State, X, Y);
        4: Result := new Treasury(State, X, Y);
      end;
    end;
    
    class function CreateRoom(X, Y: integer): Segment;
    begin
      var Rad := sqrt(sqr(X) + sqr(Y));
      if Rad > RoomDrawLimit then
      begin
        for i: integer := 0 to RoomWait.Length - 1 do
          if RoomWait[i].X = X then
            if RoomWait[i].Y = Y then
              exit;
        
        RoomWait := RoomWait + new CreateRoomParameter[1](new CreateRoomParameter(X, Y));
        exit;
      end;
      
      if Rad > MazeRad then exit;
      
      var L, R, U, D: byte;
      var SL, SR, SU, SD: Segment;
      
      SL := GetSegment(X - 1, Y);
      SR := GetSegment(X + 1, Y);
      SU := GetSegment(X, Y - 1);
      SD := GetSegment(X, Y + 1);
      
      L := SL = nil ? 1 : SL.GetData^.State.R;
      R := SR = nil ? 1 : SR.GetData^.State.L;
      U := SU = nil ? 1 : SU.GetData^.State.D;
      D := SD = nil ? 1 : SD.GetData^.State.U;
      
      Result := RandSegment(new StateT(L, R, U, D), X, Y);
      if Result = nil then
      begin
        if SL <> nil then SL.AddSR(nil);
        if SR <> nil then SR.AddSL(nil);
        if SU <> nil then SU.AddSD(nil);
        if SD <> nil then SD.AddSU(nil);
        exit;
      end;
      var State := Result.GetData^.State;
      if State.L = 2 then if SL <> nil then Result.AddSL(SL);
      if State.R = 2 then if SR <> nil then Result.AddSR(SR);
      if State.U = 2 then if SU <> nil then Result.AddSU(SU);
      if State.D = 2 then if SD <> nil then Result.AddSD(SD);
      
      if State.L = 2 then if SL <> nil then SL.AddSR(Result);
      if State.R = 2 then if SR <> nil then SR.AddSL(Result);
      if State.U = 2 then if SU <> nil then SU.AddSD(Result);
      if State.D = 2 then if SD <> nil then SD.AddSU(Result);
      
      if State.L = 2 then if SL = nil then CreateRoom(X - 1, Y);
      if State.R = 2 then if SR = nil then CreateRoom(X + 1, Y);
      if State.U = 2 then if SU = nil then CreateRoom(X, Y - 1);
      if State.D = 2 then if SD = nil then CreateRoom(X, Y + 1);
      
      var B := true;
      for i2: integer := 0 to RoomArray.Length - 1 do
        if RoomArray[i2].X = X then
          if RoomArray[i2].Y = Y then
          begin
            RoomArray[i2] := Result;
            B := false;
            break;
          end;
      if B then
        RoomArray := RoomArray + new Segment[1](Result);
    end;
    
    class function GetNew: Segment;
    begin
      Result := RandSegment(new StateT(85), 0, 0);//85 = 01 01 01 01
      RoomArray := new Segment[1](Result);
      var State := Result.GetData^.State;
      if State.L = 2 then if GetSegment(-1, 0) = nil then CreateRoom(-1, 0);
      if State.R = 2 then if GetSegment(+1, 0) = nil then CreateRoom(+1, 0);
      if State.U = 2 then if GetSegment(0, -1) = nil then CreateRoom(0, -1);
      if State.D = 2 then if GetSegment(0, +1) = nil then CreateRoom(0, +1);
    end;
    
    {$endregion}
    
    {$region Wait}
    
    class procedure CreateWaitRooms;
    begin
      for i: integer := RoomWait.Length - 1 downto 0 do
      begin
        var Rad := sqrt(sqr(RoomWait[i].X) + sqr(RoomWait[i].Y));
        if Random(Trunc(Rad - RoomDrawLimit)) = 0 then
        begin
          if Rad <= MazeRad then
          begin
            var X := RoomWait[i].X;
            var Y := RoomWait[i].Y;
            
            var Res: Segment;
            var L, R, U, D: byte;
            var SL, SR, SU, SD: Segment;
            
            SL := GetSegment(X - 1, Y);
            SR := GetSegment(X + 1, Y);
            SU := GetSegment(X, Y - 1);
            SD := GetSegment(X, Y + 1);
            
            L := SL = nil ? 1 : SL.GetData^.State.R;
            R := SR = nil ? 1 : SR.GetData^.State.L;
            U := SU = nil ? 1 : SU.GetData^.State.D;
            D := SD = nil ? 1 : SD.GetData^.State.U;
            
            Res := RandSegment(new StateT(L, R, U, D), X, Y);
            if Res = nil then
            begin
              if SL <> nil then SL.AddSR(nil);
              if SR <> nil then SR.AddSL(nil);
              if SU <> nil then SU.AddSD(nil);
              if SD <> nil then SD.AddSU(nil);
              for i2: integer := 0 to RoomArray.Length - 1 do
                if (RoomArray[i2].X = X) and (RoomArray[i2].Y = Y) then
                begin
                  RoomArray[i2] := RoomArray[RoomArray.Length - 1];
                  SetLength(RoomArray, RoomArray.Length - 1);
                  break;
                end;
              continue;
            end;
            var State := Res.GetData^.State;
            if State.L = 2 then if SL <> nil then Res.AddSL(SL);
            if State.R = 2 then if SR <> nil then Res.AddSR(SR);
            if State.U = 2 then if SU <> nil then Res.AddSU(SU);
            if State.D = 2 then if SD <> nil then Res.AddSD(SD);
            
            if State.L = 2 then if SL <> nil then SL.AddSR(Res);
            if State.R = 2 then if SR <> nil then SR.AddSL(Res);
            if State.U = 2 then if SU <> nil then SU.AddSD(Res);
            if State.D = 2 then if SD <> nil then SD.AddSU(Res);
            
            if State.L = 2 then if SL = nil then CreateRoom(X - 1, Y);
            if State.R = 2 then if SR = nil then CreateRoom(X + 1, Y);
            if State.U = 2 then if SU = nil then CreateRoom(X, Y - 1);
            if State.D = 2 then if SD = nil then CreateRoom(X, Y + 1);
            
            var B := true;
            for i2: integer := 0 to RoomArray.Length - 1 do
              if RoomArray[i2].X = X then
                if RoomArray[i2].Y = Y then
                begin
                  RoomArray[i2] := Res;
                  B := false;
                  break;
                end;
            if B then
              RoomArray := RoomArray + new Segment[1](Res);
          end;
          
          RoomWait[i] := RoomWait[RoomWait.Length - 1];
          SetLength(RoomWait, RoomWait.Length - 1);
        end;
      end;
    end;
    
    {$endregion}
    
    {$region Recreate}
    
    class procedure RecreateWait;
    begin
      RoomWait := new CreateRoomParameter[0];
      
      for i: integer := RoomArray.Length - 1 downto 0 do
        if sqrt(sqr(RoomArray[i].X) + sqr(RoomArray[i].Y)) > MazeMaxRad then
        begin
          var Data := RoomArray[i].GetData^;
          var SL := Data.S[2];
          var SR := Data.S[0];
          var SU := Data.S[3];
          var SD := Data.S[1];
          
          if SL <> nil then SL.AddSR(nil);
          if SR <> nil then SR.AddSL(nil);
          if SU <> nil then SU.AddSD(nil);
          if SD <> nil then SD.AddSU(nil);
          
          RoomArray[i] := RoomArray[RoomArray.Length - 1];
          SetLength(RoomArray, RoomArray.Length - 1);
        end;
      
      for i: integer := 0 to RoomArray.Length - 1 do
        RoomWait := RoomWait + RoomArray[i].GetEmpty();
    end;
  
  {$endregion}
  
  end;
  
  
  Wep1zv = record
    X, Y, dX, dY: real;
  end;
  
  Wep3ProjT = record
    dir, vel: Single;
  end;
  
  Wep3Boom = record
    const StAdd = 1.5;
    const StRandAdd = 0.5;
    const mlt = 25;
    
    X, Y, lvl, Stage, Rot, RotSp: Single;
    pts: array of Single;
    
    function Draw: array of PointF;
    begin
      Result := new PointF[pts.Length];
      var rpp := Pi * 2 / pts.Length;
      for i: integer := 0 to pts.Length - 1 do
        Result[i] := new PointF(X + pts[i] * lvl * mlt * Cos(rpp * i + Rot) * Sin(Stage), Y + pts[i] * lvl * mlt * Sin(rpp * i + Rot) * Sin(Stage));
      
      Rot += RotSp;
      Stage += StAdd + StRandAdd * (Random * 2 - 1);
    end;
    
    constructor create(X, Y, lvl, RotSp: Single);
    begin
      self.X := X;
      self.Y := Y;
      self.lvl := lvl;
      self.RotSp := RotSp;
      Stage := 0;
      Rot := Random * Pi * 2;
      pts := new Single[Random(15) + 5];
      while true do
      begin
        pts[0] := 0.7 + Random * 0.3;
        for i: integer := 1 to pts.Length - 1 do
          repeat
            pts[i] := 0.7 + Random * 0.3;
          until abs(pts[i] - pts[i - 1]) > 0.1;
        if abs(pts[0] - pts[pts.Length - 1]) > 0.1 then
          break;
      end;
    end;
  end;

function GetKeyState(nVirtKey: byte): byte;external 'User32.dll' name 'GetKeyState';

var
  RedrawThread: System.Threading.Thread;
  MW := 1;
  
  k9 := GetKeyState(9) div 128 = 1;

function MouseStay(P: Point): Point;
begin
  if k9 <> (GetKeyState(9) div 128 = 1) then
  begin
    P := new Point(Round(WW / 2), Round(WH / 2));
    k9 := not k9;
  end;
  if k9 then exit;
  
  var dx := P.X - WW / 2;
  var dy := P.Y - WH / 2;
  
  begin
    var r := sqrt(sqr(dx) + sqr(dy));
    if r > 350 then
    begin
      dx *= 350 / r;
      dy *= 350 / r;
      
      P.X := Round(dx + WW / 2);
      P.Y := Round(dy + WH / 2);
    end;
  end;
  
  Result := P;
  
  Player.dX += dx;
  Player.dY += dy;
  
  System.Windows.Forms.Cursor.Position := new Point(Round(WW / 2), Round(WH / 2));
end;

procedure OnMouseWheel(sender: System.Object; e: System.Windows.Forms.MouseEventArgs);
begin
  if e.Delta > 0 then MW += 1 else
  if e.Delta < 0 then MW -= 1;
end;

procedure Redrawing;
{$region Start}
var
  tempbmp := new Bitmap(WW, WH);
  bmp := Graphics.FromImage(tempbmp);
  
  Brush := new SolidBrush(Color.Empty);
  Pen := new System.drawing.Pen(Color.Empty);
  
  Room: Segment;
  RRect := new System.Drawing.RectangleF(-RW / 2, -RW / 2, RW, RW);
  
  l: array of PointF;
  Weapon, nWeapon: byte;
  //1:  WepN: ???
  //2:  Draw->WepN
  //3:  Weapon->Select
  //4:  Weapon->WepN
  
  MapL := new PointF[2](new PointF(-5, 3), new PointF(-5, -3));
  MapR := new PointF[2](new PointF(5, -3), new PointF(5, 3));
  MapU := new PointF[2](new PointF(-3, -5), new PointF(3, -5));
  MapD := new PointF[2](new PointF(3, 5), new PointF(-3, 5));
  
  MapLU := new PointF[1](new PointF(-3, -3));
  MapLD := new PointF[1](new PointF(-3, 3));
  MapRU := new PointF[1](new PointF(3, -3));
  MapRD := new PointF[1](new PointF(3, 3));
  
  Viewpoint := new PointF(0, 0);
  
  Wep1: array of Wep1zv;
  Wep1End := new PointF[8](new PointF(0, 15), new PointF(-5, 5), new PointF(-15, 0), new PointF(-5, -5), new PointF(0, -15), new PointF(5, -5), new PointF(15, 0), new PointF(5, 5));
  
  Wep2rot: real;
  Wep2L, Wep2dL: real;
  Wep2Grip := new PointF[10](new PointF(9, 3.5), new PointF(9, 7), new PointF(6, 7), new PointF(6, 1.5), new PointF(0, 1.5), new PointF(0, -1.5), new PointF(6, -1.5), new PointF(6, -7), new PointF(9, -7), new PointF(9, -3.5));
  Wep2Blade := new PointF[3](new PointF(9, -3.5), new PointF(15, 0), new PointF(9, 3.5));
  nWep2: array of PointF;
  
  Wep3 := new PointF[3](new PointF(0, -3), new PointF(0, 3), new PointF(25, 0));
  Wep3p2 := new PointF[3](new PointF(21, -10), new PointF(25, 0), new PointF(21, 10));
  Wep3p3 := new PointF[3](new PointF(21, -10), new PointF(25, 0), new PointF(21, 10));
  Wep3Charge: Single;
  Wep3fly := false;
  Wep3Proj: Wep3ProjT;
  Wep3Rocket := new PointF[7](new PointF(-20, -6), new PointF(0, -6), new PointF(11, -2), new PointF(12, 0), new PointF(11, 2), new PointF(0, 6), new PointF(-20, 6));
  Wep3Booms := new Wep3Boom[0];

begin
  Room := Dangeon.GetNew;
  var EyeSight := new Bitmap(WW, WH);
  Textures.HpIcon.MakeTransparent;
  
  for x: integer := 0 to WW - 1 do
    for y: integer := 0 to WH - 1 do
    begin
      var c := 430 - 300000 / Power(sqrt(sqr(WW / 2 - x) + sqr(WH / 2 - y)), 1.2);
      if c.Equals(real.NaN) then c := 0 else
      begin
        if c > 255 then c := 255;
        if c < 0 then c := 0;
      end;
      EyeSight.SetPixel(x, y, Color.FromArgb(Round(c), 0, 0, 0));
    end;
  
  StartForm;
  System.Windows.Forms.Cursor.Position := new Point(WW div 2, WH div 2);
  MainForm.Cursor.Dispose;
  MainForm.MouseWheel += OnMouseWheel;
  
  //readln;
  
  l := Add(Room.Draw(0, RoomDrawLimit), WW / 2 - RW / 2, WH / 2 - RW / 2);
  {$endregion}
  var tc: integer;
  while true do
    try
      if tc = 0 then
        Milliseconds;
      {$region Navigation}{
      -Draw
        -Common
          -Toolbar
            -Wep1
            -Wep2
            -Wep3
          -Player
        -Wep1
        -Wep2
        -Wep3
        -Map
      -Weapon
        -Select
        -W1
        -W2
        -W3
      -Calc
      {$endregion}
      
      {$region Draw}
      {$region Common}
      bmp.DrawImage(EyeSight, 0, 0);
      
      if (not Wep3fly) then
        if sqrt(sqr(Viewpoint.X) + sqr(Viewpoint.Y)) < 1 then
          Viewpoint := new PointF(0, 0) else
          Viewpoint := new PointF(Viewpoint.X * 0.7, Viewpoint.Y * 0.7);
      
      {$region Toolbar}
      begin
        var w := WW / 3;
        w := Min(w, w / 200 * Player.Hp);
        Brush.Color := Color.Red;
        bmp.FillRectangle(Brush, WW - 10 - w, 10, w, 40);
        Pen.Color := Color.Purple;
        bmp.DrawRectangle(Pen, WW / 3 * 2 - 10, 10, WW / 3, 40);
        bmp.DrawImage(Textures.HpIcon, WW - Textures.HpIcon.Width, 0);
      end;
      
      {$region Wep1}
      if Weapon = 1 then
      begin
        Brush.Color := Color.FromArgb(255, 150, 150, 150);
        for i: integer := 0 to Wep1.Length - 2 do
          bmp.FillEllipse(Brush, 10 + i * 10, 13.5, 3, 3);
        Brush.Color := Color.FromArgb(255, 255, 0, 0);
        bmp.FillPolygon(Brush, Add(Copy(Wep1End), 10 + Wep1.Length * 10, 15));
        Pen.Color := Color.Red;
        var px2 := 27 + Wep1.Length * 10;
        bmp.DrawLines(Pen, new PointF[4](new PointF(3, 17), new PointF(3, 32), new PointF(px2, 32), new PointF(px2, 17)));
        var s := Wep1.Length.ToString;
        if nWeapon <> 1 then
          s += ' (' + Max(Min(Wep1.Length - MW - 1, 15), 0) + ')' else
        if MW <> 0 then
          s += ' (' + Max(Min(Wep1.Length - MW, 15), 1) + ')';
        var sz := bmp.MeasureString(s, new Font('Times New Roman', 12));
        bmp.DrawString(s, new Font('Times New Roman', 12), Brush, (px2 + 3 - sz.Width) / 2, 35);
      end else
      {$endregion}
      {$region Wep1}
      if Weapon = 2 then
      begin
        
      end else
      {$endregion}
      {$region Wep3}
      if Weapon = 3 then
      begin
        Brush.Color := Color.FromArgb(255, 179, 89, 39);
        bmp.FillRectangle(Brush, 10, 10, WW / 3 * Wep3Charge, 40);
        Pen.Color := Color.Purple;
        bmp.DrawRectangle(Pen, 10, 10, WW / 3, 40);
      end else
      {$endregion}
      ;
      {$endregion}
      
      gr.DrawImage(tempbmp, 0, 0);
      Brush.Color := Color.Black;
      bmp.FillRectangle(Brush, 0, 0, WW, WH);
      Brush.Color := Color.White;
      var dRoom := Dangeon.GetSegment(Round((Viewpoint.X + Player.X) / RW), Round((Viewpoint.Y + Player.Y) / RW));
      var dVP := new PointF(Player.X + Viewpoint.X - dRoom.X * RW, Player.Y + Viewpoint.Y - dRoom.Y * RW);
      
      l := Add(dRoom.Draw(0, RoomDrawLimit), WW / 2 - RW / 2 - dVP.X, WH / 2 - RW / 2 - dVP.Y);
      
      bmp.FillPolygon(Brush, l);
      
      Brush.Color := Color.Red;
      with MouseStay(System.Windows.Forms.Cursor.Position) do
        bmp.FillEllipse(Brush, X - 3, Y - 3, 6, 6);
      
      
      {$region Player}
      Pen.Color := Color.Black;
      Pen.Width := 3;
      
      
      
      Pen.Width := 1;
      {$endregion}
      
      {$region Booms}
      for i: integer := Wep3Booms.Length - 1 downto 0 do
        with Wep3Booms[i] do
        begin
          var lvlmlt := lvl * mlt;
          begin
            var r := sqrt(sqr(X - Player.X) + sqr(Y - Player.Y));
            if r < power(lvlmlt, 1.3) then
            begin
              Player.Hp -= lvlmlt / Power(r, 1.5) * 100;
              Player.dX -= (X - Player.X) / Power(r, 1.2) * lvlmlt / 3;
              Player.dY -= (Y - Player.Y) / Power(r, 1.2) * lvlmlt / 3;
            end;
            
            //ToDo Entitys
          end;
          
          var St := Stage;
          var Dpts := Add(Draw, WW / 2 - Player.X, WH / 2 - Player.Y);
          Brush.Color := Color.Yellow;
          Pen.Color := Color.Red;
          bmp.FillPolygon(Brush, Dpts);
          bmp.DrawPolygon(Pen, Dpts);
          
          if (St < Pi / 2) and (Stage > Pi / 2) then
          begin
            if lvl > 2 then
              for n: integer := 0 to 1 + Random(2) do
                Wep3Booms := Wep3Booms + new Wep3Boom[1](new Wep3Boom(X + lvlmlt * (Random * 2 - 1), Y + lvlmlt * (Random * 2 - 1), lvl - 3 - Random * 3, Max(Min(RotSp + Random - 0.5, 1), -1)));
          end else
          if Stage > Pi then
          begin
            Wep3Booms[i] := Wep3Booms[Wep3Booms.Length - 1];
            SetLength(Wep3Booms, Wep3Booms.Length - 1);
          end;
        end;
      {$endregion}
      {$endregion}
      
      {$region Wep1}
      if Weapon = 1 then
      begin
        Brush.Color := Color.FromArgb(255, 150, 150, 150);
        for i: integer := 0 to Wep1.Length - 2 do
        begin
          bmp.FillEllipse(Brush, WW / 2 - Player.X + Wep1[i].X - 2, WH / 2 - Player.Y + Wep1[i].Y - 2, 4, 4);
        end;
        Brush.Color := Color.FromArgb(255, 255, 0, 0);
        bmp.FillPolygon(Brush, Add(Copy(Wep1End), WW / 2 - Player.X + Wep1[Wep1.Length - 1].X, WH / 2 - Player.Y + Wep1[Wep1.Length - 1].Y));
      end else
      {$endregion}
      {$region Wep2}
      if Weapon = 2 then
      begin
        nWep2 := Add(Rotate(Wep2Grip + Add(Copy(Wep2Blade), Wep2L, 0), Wep2rot), WW / 2, WH / 2);
        
        Pen.Color := Color.Black;
        Brush.Color := Color.FromArgb(255, 200, 200, 200);
        
        bmp.FillPolygon(Brush, nWep2);
        bmp.DrawPolygon(Pen, nWep2);
      end else
      {$endregion}
      {$region Wep3}
      if Weapon = 3 then
      begin
        if Wep3fly then
        begin
          var nWep3Rocket := Add(Rotate(Copy(Wep3Rocket), Wep3Proj.dir), WW / 2, WH / 2);
          Brush.Color := Color.Gray;
          bmp.FillPolygon(Brush, nWep3Rocket);
          var Jet := Add(new PointF[13], -20, 0);
          for i: integer := 0 to Jet.Length - 1 do
            Jet[i].Y := i - 6;
          for i: integer := 1 to Jet.Length - 2 do
            Jet[i].X -= Random * Wep3Proj.vel;
          Rotate(Jet, Wep3Proj.dir);
          Add(Jet, WW / 2, WH / 2);
          Brush.Color := Color.Red;
          bmp.FillPolygon(Brush, Jet);
        end;
        
        var nWep3 := Add(Rotate(Copy(Wep3), Player.Rot), WW / 2 - Viewpoint.X, WH / 2 - Viewpoint.Y);
        var nWep3p2 := Add(Rotate(Copy(Wep3p2), Player.Rot), WW / 2 - Viewpoint.X, WH / 2 - Viewpoint.Y);
        var nWep3p3 := Add(Rotate(Copy(Wep3p3), Player.Rot), WW / 2 - Viewpoint.X, WH / 2 - Viewpoint.Y);
        
        Pen.Color := Color.Black;
        Pen.Width := 3;
        Brush.Color := Color.FromArgb(255, 179, 89, 39);
        Pen.Color := Color.FromArgb(255, 79, 89, 39);
        
        bmp.FillPolygon(Brush, nWep3);
        bmp.DrawCurve(Pen, nWep3p2);
        bmp.DrawCurve(Pen, nWep3p3);
        
        Pen.Width := 1;
      end else
      {$endregion}
      ;
      
      {$region Map}
      if k9 then
      begin
        Brush.Color := Color.FromArgb(255, 150, 50, 50);
        bmp.FillRectangle(Brush, WW / 2 - MapW * 10 - 15, WH / 2 - MapH * 10 - 15, MapW * 20 + 30, MapH * 20 + 30);
        
        for i: integer := 0 to Dangeon.RoomArray.Length - 1 do
          with Dangeon.RoomArray[i] do
            if abs(X - Room.X) <= MapW then
              if abs(Y - Room.Y) <= MapH then
              begin
                var St := GetData^.State;
                var nl := (St.R = 0 ? aPF0 : MapR) + MapRD + (St.D = 0 ? aPF0 : MapD) + MapLD + (St.L = 0 ? aPF0 : MapL) + MapLU + (St.U = 0 ? aPF0 : MapU) + MapRU;
                Add(nl, WW / 2 + 10 * (X - Room.X), WH / 2 + 10 * (Y - Room.Y));
                Brush.Color := (X = Room.X) and (Y = Room.Y) ? Color.Green : Color.White;
                bmp.FillPolygon(Brush, nl);
              end;
        
        for i: integer := 0 to Dangeon.RoomWait.Length - 1 do
          with Dangeon.RoomWait[i] do
            if abs(X - Room.X) <= MapW then
              if abs(Y - Room.Y) <= MapH then
              begin
                var nl := MapRD + MapLD + MapLU +   MapRU;
                Add(nl, WW / 2 + 10 * (X - Room.X), WH / 2 + 10 * (Y - Room.Y));
                Brush.Color := Color.Blue;
                bmp.FillPolygon(Brush, nl);
              end;
      end;
      {$endregion}
      {$endregion}
      {$region Weapon}
      
      {$region Select}
      if GetKeyState(48) div 128 = 1 then nWeapon := 0 else
      if GetKeyState(49) div 128 = 1 then nWeapon := 1 else
      if GetKeyState(50) div 128 = 1 then nWeapon := 2 else
      if GetKeyState(51) div 128 = 1 then nWeapon := 3 else
      ;
      
      if Weapon <> nWeapon then
        if Weapon = 0 then
        begin
          if nWeapon = 1 then
          begin
            Wep1 := new Wep1zv[1];
            Wep1[0].X := Player.X;
            Wep1[0].dX := 0;
            Wep1[0].Y := Player.Y;
            Wep1[0].dY := 0;
            MW := 0;
          end else
          if nWeapon = 2 then
          begin
            Wep2L := 5;
            Wep2dL := 0;
            MW := 0;
            Wep2rot := Player.Rot;
          end else
          if nWeapon = 3 then
          begin
            Wep3Charge := 0;
            MW := 0;
          end;
          Weapon := nWeapon;
        end else
        
        
        if Weapon = 1 then
        begin
          if Wep1.Length = 1 then
          begin
            SetLength(Wep1, 0);
            Weapon := 0;
          end else
          if sqrt(sqr(Wep1[0].X - Player.X) + sqr(Wep1[0].Y - Player.Y)) < 9 then
          begin
            for i: integer := 0 to Wep1.Length - 2 do
              Wep1[i] := Wep1[i + 1];
            SetLength(Wep1, Wep1.Length - 1);
          end;
        end else
        if Weapon = 2 then
        begin
          Weapon := 0;
        end else
        if Weapon = 3 then
        begin
          Wep3p3[1].X := 25;
          if not Wep3fly then
            Weapon := 0;
        end;
      {$endregion}
      
      {$region W1}
      if Weapon = 1 then
      begin
        begin
          var r := sqrt(sqr(Wep1[0].X - Player.X) + sqr(Wep1[0].Y - Player.Y));
          var del1 := 1.1;
          var del2 := (20 - Wep1.Length);
          if r > 0 then
            if Wep1.Length > 1 then
              if r < 1 then
              begin
                Wep1[0].dX += (Wep1[0].X - Player.X) / r * (1 - r) / del1;
                Wep1[0].dY += (Wep1[0].Y - Player.Y) / r * (1 - r) / del1;
                Player.dX -= (Wep1[0].X - Player.X) / r * (1 - r) / del2;
                Player.dY -= (Wep1[0].Y - Player.Y) / r * (1 - r) / del2;
              end else
              if r > 2 then
              begin
                Wep1[0].dX -= (Wep1[0].X - Player.X) / r * (r - 2) / del1;
                Wep1[0].dY -= (Wep1[0].Y - Player.Y) / r * (r - 2) / del1;
                Player.dX += (Wep1[0].X - Player.X) / r * (r - 2) / del2;
                Player.dY += (Wep1[0].Y - Player.Y) / r * (r - 2) / del2;
              end;
        end;
        
        for i: integer := 0 to Wep1.Length - 2 do
        begin
          var r := sqrt(sqr(Wep1[i].X - Wep1[i + 1].X) + sqr(Wep1[i].Y - Wep1[i + 1].Y));
          var del1 := 1.1;
          var del2 := i = Wep1.Length - 2 ? 5.0 : del1;
          if r > 0 then
            if r < 1 then
            begin
              Wep1[i].dX += (Wep1[i].X - Wep1[i + 1].X) / r * (1 - r) / del1;
              Wep1[i].dY += (Wep1[i].Y - Wep1[i + 1].Y) / r * (1 - r) / del1;
              Wep1[i + 1].dX -= (Wep1[i].X - Wep1[i + 1].X) / r * (1 - r) / del2;
              Wep1[i + 1].dY -= (Wep1[i].Y - Wep1[i + 1].Y) / r * (1 - r) / del2;
            end else
            if r > 2 then
            begin
              Wep1[i].dX -= (Wep1[i].X - Wep1[i + 1].X) / r * (r - 2) / del1;
              Wep1[i].dY -= (Wep1[i].Y - Wep1[i + 1].Y) / r * (r - 2) / del1;
              Wep1[i + 1].dX += (Wep1[i].X - Wep1[i + 1].X) / r * (r - 2) / del2;
              Wep1[i + 1].dY += (Wep1[i].Y - Wep1[i + 1].Y) / r * (r - 2) / del2;
            end;
        end;
        
        if Wep1.Length = 1 then
        begin
          var r := sqrt(sqr(Wep1[0].X - Player.X) + sqr(Wep1[0].Y - Player.Y));
          var nr := 10;
          if r = 0 then
          begin
            r := 1;nr := 1;
          end;
          var nX := Player.X + (Wep1[0].X - Player.X) / r * nr;
          var nY := Player.Y + (Wep1[0].Y - Player.Y) / r * nr;
          Wep1[0].dX := (nX - Wep1[0].X) * 0.8;
          Wep1[0].dY := (nY - Wep1[0].Y) * 0.8;
        end;
        
        for i: integer := 0 to Wep1.Length - 1 do
          with Wep1[i] do
          begin
            var Sp := new PointF(dX, dY);
            
            TestHit(i = Wep1.Length - 1 ? 15 : 5, l, new PointF(WW / 2 + X - Player.X, WH / 2 + Y - Player.Y), Sp);
            
            dX := Sp.X;
            dY := Sp.Y;
          end;
        
        for i: integer := 0 to Wep1.Length - 2 do
        begin
          Wep1[i].dX *= 0.8;
          Wep1[i].dY *= 0.8;
        end;
        if Wep1.Length > 1 then
        begin
          var dr := (1 - 1 / sqrt(sqr(Wep1[Wep1.Length - 1].X - Wep1[Wep1.Length - 2].X) + sqr(Wep1[Wep1.Length - 1].Y - Wep1[Wep1.Length - 2].Y)));
          if dr.Equals(real.NegativeInfinity) then dr := 1 else
            dr := Power(dr, 15);
          Wep1[Wep1.Length - 1].dX *= dr;
          Wep1[Wep1.Length - 1].dY *= dr;
        end;
        for i: integer := 0 to Wep1.Length - 1 do
        begin
          Wep1[i].X += Wep1[i].dX;
          Wep1[i].Y += Wep1[i].dY;
        end;
        
        if Wep1.Length - MW < 1 then MW := Wep1.Length - 1 else
        if Wep1.Length - MW > 15 then MW := Wep1.Length - 15;
        if MW > 0 then
        begin
          if Wep1.Length = 1 then MW := 0 else
          if sqrt(sqr(Wep1[0].X - Player.X) + sqr(Wep1[0].Y - Player.Y)) < 9 then
          begin
            for i: integer := 0 to Wep1.Length - 2 do
              Wep1[i] := Wep1[i + 1];
            SetLength(Wep1, Wep1.Length - 1);
            MW -= 1;
          end;
        end else if MW < 0 then
        begin
          if Wep1.Length < 15 then
          begin
            SetLength(Wep1, Wep1.Length + 1);
            for i: integer := Wep1.Length - 2 downto 0 do
              Wep1[i + 1] := Wep1[i];
            Wep1[0].X := (Wep1[1].X + Player.X) / 2;
            Wep1[0].Y := (Wep1[1].Y + Player.Y) / 2;
            MW += 1;
          end else
            MW := 0;
        end;
      end else
      {$endregion}
      {$region W2}
      if Weapon = 2 then
      begin
        if MW <> 0 then
        begin
          Wep2dL += MW * 3;
          MW := 0;
        end;
        
        Wep2L += Wep2dL;
        if Wep2L < 5 then
        begin
          Wep2L := 5;
          Wep2dL := 0;
        end else
        if Wep2L > 35 then
        begin
          Wep2L := 35;
          Wep2dL := 0;
        end;
        
        Wep2dL *= 0.5;
        begin
          var dr: real;
          with Player do
            dr := sqrt(sqr(dX) + sqr(dY));
          if dr <> 0 then
          begin
            dr := 1 - 1 / power(dr, 0.3);
            
            if dr < 0 then dr := 0;
            
            var dr1 := Player.Rot - Wep2rot;
            var dr2 := Wep2rot - Player.Rot;
            if dr1 < 0 then dr1 += 2 * Pi;// else if dr1 > Pi then dr1 -= 2*Pi;
            if dr2 < 0 then dr2 += 2 * Pi;// else if dr2 > Pi then dr2 -= 2*Pi;
            
            if abs(dr1) < abs(dr2) then
            begin
              if dr1 < -Pi then dr1 += 2 * Pi else if dr1 > Pi then dr1 -= 2 * Pi;
              Wep2rot += dr1 * dr / 3;
            end else
            begin
              if dr2 < -Pi then dr2 += 2 * Pi else if dr2 > Pi then dr2 -= 2 * Pi;
              Wep2rot -= dr2 * dr * 5 / Wep2L;
            end;
            
            if Wep2rot > 2 * Pi then Wep2rot -= 2 * Pi;
            if Wep2rot < 0 then Wep2rot += 2 * Pi;
          end;
        end;
        
        try
          var Sp := new PointF(Player.dX, Player.dY);
          TestHit(Wep2L, l, nWep2[11], Sp);
          Player.dX := Sp.X;
          Player.dY := Sp.Y;
        except
        end;
      end;
      {$endregion}
      {$region W3}
      if Weapon = 3 then
      begin
        if MW <> 0 then
        begin
          if not Wep3fly then
            if MW < 0 then
              Wep3Charge += 0.06;
          if Wep3Charge > 1 then Wep3Charge := 1;
          Wep3p3[1].X := 25 - 12 * Wep3Charge;
          MW := 0;
        end;
        
        if not Wep3fly then
          if Wep3Charge = 1 then
            if GetKeyState(4) div 128 = 1 then
            begin
              Wep3fly := true;
              Wep3Proj.dir := Player.Rot;
              Wep3Proj.vel := 5;
              Player.dX := 0;
              Player.dY := 0;
              Wep3Charge := 0;
              Wep3p3[1].X := 25;
            end;
        
        if Wep3fly then
        begin
          var SP := new PointF(Wep3Proj.vel * Cos(Wep3Proj.dir), Wep3Proj.vel * Sin(Wep3Proj.dir));
          
          var nSP := SP;
          begin
            var from := new PointF(WW / 2, WH / 2);
            TestHit(20, l, from, nSP);
          end;
          
          if nSP <> SP then
          begin
            Wep3Booms := Wep3Booms + new Wep3Boom[1](new Wep3Boom(Player.X + Viewpoint.X + nSP.X, Player.Y + Viewpoint.Y + nSP.Y, Wep3Proj.vel, Random - 0.5));
            
            Wep3fly := false;
          end else
          begin
            Viewpoint.X += SP.X;
            Viewpoint.Y += SP.Y;
            
            if Player.dY < 0 then
              Wep3Proj.vel += (15 - Wep3Proj.vel) * 0.1 else
            if Player.dY > 0 then
              Wep3Proj.vel += (5 - Wep3Proj.vel) * 0.1;
            if Wep3Proj.vel < 5 then Wep3Proj.vel := 5 else
            if Wep3Proj.vel > 15 then Wep3Proj.vel := 15;
            Wep3Proj.dir += Player.dX / 2000;
            Player.dX := 0;
            Player.dY := 0;
          end;
        end;
      end;
      {$endregion}
      
      {$region W0}
      if Weapon = 0 then
      begin
        
      end;
      {$endregion}
      {$endregion}
      {$region Calc}
      
      begin
        Player.Hp += 0.1;
        if Player.Hp > 200 then Player.Hp := 200;
        if Player.Hp < 0 then Player.Hp := 0;
      end;
      
      if not Wep3fly then
      begin
        Player.Rot := ArcTg(Player.dX, Player.dY);
        var Sp := new PointF(Player.dX, Player.dY);
        
        TestHit(10, l, new PointF(WW / 2 - Viewpoint.X, WH / 2 - Viewpoint.Y), Sp);
        
        if Sp = new PointF(Player.dX, Player.dY) then
        begin
          var dx := Sp.X * 0.5;
          var dy := Sp.Y * 0.5;
          Player.X += dx;Player.Y += dy;
          Player.dX -= dx;Player.dY -= dy;
        end else
        begin
          Player.dX := 0;
          Player.dY := 0;
          Player.X += Sp.X;
          Player.Y += Sp.Y;
        end;
      end;
      
      if not RRect.Contains(Player.X, Player.Y) then
      begin
        var Sh := new Point(0, 0);
        var Data := Room.GetData^;
        if Player.X < RRect.Left then
        begin
          Room := Data.S[2];
          Sh.X := -RW;
        end else if Player.X > RRect.Right then
        begin
          Room := Data.S[0];
          Sh.X := RW;
        end else if Player.Y < RRect.Top then
        begin
          Room := Data.S[3];
          Sh.Y := -RW;
        end else if Player.Y > RRect.Bottom then
        begin
          Room := Data.S[1];
          Sh.Y := RW;
        end;
        
        Player.X -= Sh.X;
        Player.Y -= Sh.Y;
        
        if Weapon = 1 then
          for i: integer := 0 to Wep1.Length - 1 do
          begin
            Wep1[i].X -= Sh.X;
            Wep1[i].Y -= Sh.Y;
          end;
        
        for i: integer := 0 to Wep3Booms.Length - 1 do
        begin
          Wep3Booms[i].X -= Sh.X;
          Wep3Booms[i].Y -= Sh.Y;
        end;
        
        var X := Room.X;var Y := Room.Y;
        
        for i: integer := 0 to Dangeon.RoomArray.Length - 1 do
          Dangeon.RoomArray[i].SetPos(Dangeon.RoomArray[i].X - X, Dangeon.RoomArray[i].Y - Y);
        Dangeon.RecreateWait;
      end;
      
      Dangeon.CreateWaitRooms;
      
      {$endregion}
      
      tc += 1;
      if tc = 60 then
      begin
        writeln(MillisecondsDelta);
        tc := 0;
      end;
    except
      on e: system.Exception do
        writeln(e);
    end;
end;

begin
  InitForm;
  RedrawThread := new System.Threading.Thread(Redrawing);
  RedrawThread.Start;
end.